/**
*UOffice App
* Implementing UOffice App
*/
var UOfficeApp = UOfficeApp || {};  //Define UOffice App namespace.
/**
*Constructor UNAS App
*/
UOfficeApp.App = function () {
    this.id = 'UOffice';
    this.name = 'UOffice';
    this.version = '6.0.7';
    this.active = false;
    this.menuIcon = '/apps/uoffice/images/logo.png?v=6.0.7&';
    this.shortcutIcon = '/apps/uoffice/images/logo.png?v=6.0.7&';
    this.entryUrl = '/apps/uoffice/uoffice.html?v=6.0.7&';
    //this.entryHelpUrl = '/apps/uoffice/OnlyOffice_help.html?v=6.0.7&';
    var self = this;
    this.UOfficeAppWindow = function () {
    	if(UNAS.CheckAppState('UOffice')){
    		return false;
    	}
    	self.window=new MUI.Window({
            id: 'UOfficeAppWindow',
            title: UNAS._('UOffice'),
            icon: '/apps/uoffice/images/logo_small.png?v=6.0.7&',
            loadMethod: 'xhr',
            width: 750,
            height: 480,
            maximizable: false,
            resizable: true,
            scrollbars: false,
            resizeLimit: { 'x': [650, 1200], 'y': [450, 900] },
            contentURL: '/apps/uoffice/uoffice.html?v=6.0.7&',
            require: {  css: ['/apps/uoffice/css/uoffice.css'] },
            onBeforeBuild: function(){UNAS.SetAppOpenedWindow("UOffice",'UOfficeAppWindow')}
     	});
    };
    this.UOfficeUninstall = function (){
    	UNAS.RemoveDesktopShortcut('UOffice');
    	UNAS.RemoveMenu('UOffice');
    	//UNAS.RemoveAppFromGroups('UOffice', 'Help');
    	UNAS.RemoveAppFromGroups('UOffice', 'ControlPanel');
    	UNAS.RemoveAppFromApps('UOffice');
    };
    new UNAS.Menu('UNAS_App_Universal_Menu', this.name, this.menuIcon, 'UOffice', '', this.UOfficeAppWindow);
    // new UNAS.DesktopShortcut(this.name, this.shortcutIcon, 'UOffice', this.UOfficeAppWindow);
    // new UNAS.RegisterToAppGroup(this.name, 'ControlPanel', {'Type' : 'Universal', 'Laction' : 11, "Icon": this.shortcutIcon, "Url": this.entryUrl},{});
    //new UNAS.RegisterToAppGroup(this.name, 'Help', {'Type' : 'Internet', 'Laction' : 3, "Icon": this.shortcutIcon, "Url": this.entryHelpUrl},{});
    var OnChangeLanguage = function (e) {
    	UNAS.SetMenuTitle('UOffice', UNAS._('UOffice')); //translate menu
        UNAS.SetShortcutTitle('UOffice', UNAS._('UOffice'));
        if (typeof self.window !== 'undefined') {
        	UNAS.SetWindowTitle('UOfficeAppWindow', UNAS._('UOffice'));
        }
    };
    UNAS.LoadTranslation('/apps/uoffice/languages/Translation?v='+this.version, OnChangeLanguage);
    UNAS.Event.addEvent('ChangeLanguage', OnChangeLanguage);
    UNAS.CreateApp(this.name, this.shortcutIcon, this.UOfficeAppWindow, this.UOfficeUninstall);
};

new UOfficeApp.App();
